# -*- coding: latin1 -*- (excepciones

# Representa los errores que surgen durante el anlisis; no los errores
# en tiempo de ejecucin
class Errores:
  def __init__(self):
    self.inicializa()

  def inicializa(self):
    self.e = []

  def dataRep(self, nl):
    self.e.append("Error lnea %4d: slo puede aparecer una directiva '.data'." % nl)

  def dataDespuesText(self, nl):
    self.e.append("Error lnea %4d: la directiva '.data' debe aparecer antes de la directiva '.text'." % nl)

  def dataSinAsciiz(self, nl):
    self.e.append("Error lnea %4d: la zona de definicin de datos est vaca." % nl)

  def textRep(self, nl):
    self.e.append("Error lnea %4d: slo puede aparecer una directiva '.text'." % nl)

  def asciizError(self, nl):
    self.e.append("Error lnea %4d: la directiva '.asciiz' slo puede aparecer en la zona de definicin de datos." % nl)

  def instrAntesText(self, nl):
    self.e.append("Error lnea %4d: instruccin antes de la directiva '.text'." % nl)

  def finError(self, nl):
    self.e.append("Error lnea %4d: fin de fichero inesperado." % nl)
    
  def instrError(self, nl):
    self.e.append("Error lnea %4d: instruccin no vlida." % nl)

  def lineaError(self, nl):
    self.e.append("Error lnea %4d: lnea incorrecta." % nl)

  def numArgsError(self, nl):
    self.e.append("Error lnea %4d: nmero de campos incorrecto." % nl)

  def formatoArgsError(self, nl, ins, arg, tipo):
    self.e.append("Error lnea %4d: El %sargumento de la instruccin '%s' debe ser %s." % \
                   (nl, argumentos[arg], ins, tipos[tipo]))

  def etiqNoDefError(self, et, nl):
    self.e.append("Error lnea %4d: etiqueta '%s' no definida." % (nl,et))

  def etiqRedefError(self, et, nl):
    self.e.append("Error lnea %4d: etiqueta '%s' redefinida." % (nl, et))

# Los siguientes diccionarios ayudan a emitir los mensajes de error

argumentos = { 0: "",
               1: "primer ",
	       2: "segundo ",
	       3: "tercer "
	     }

tipos = { "r": "un registro entero",
          "f": "un registro real",
	  "R": "un inmediato entero",
	  "F": "un inmediato real",
	  "e": "una etiqueta",
	  "n": "un indirecto a registro"
	}

################################################
# Errores en tiempo de ejecucin (EXCEPCIONES) #
################################################

SysNoCodError = "El registro $sc no contiene el cdigo de la llamada al sistema."
SysCodError = "Cdigo de llamada al sistema no vlido (%d)."
SysCharError = "Carcter no vlido (%d)."
SysEnteroError = "El valor introducido no es un entero vlido (%s)"
SysRealError = "El valor introducido no es un real vlido (%s)."
RegVacioError = "El registro %s no contiene ningn valor."
MemEnteroError = "La posicin de memoria %d no contiene un entero."
MemRealError = "La posicin de memoria %d no contiene un real."
MemAccesoError = "La posicin de memoria %d no est inicializada."
MemDirNegError = "Acceso a una posicin de memoria negativa (%d)"
DivZeroError = "Divisin por cero."
ModZeroError = "Mdulo con divisor cero."
JDestError = "El destino del salto (lnea %d) no es la instruccin posterior\n" + \
             "a ninguna instruccin jal ni jalr, ni est etiquetado."
